(******************************************************************************)
(*                                 STORE.PAS                                  *)
(*                          File Handling Benchmark.                          *)
(******************************************************************************)

PROGRAM Store(Output);

(******************************************************************************)
(*                                TIMING                                      *)
(******************************************************************************)

(*$IFNDEF TopSpeed *)
(*%F TRUE   *** Compile for Turbo Pascal ***)
  USES TPBench;
(*%E*)
(*$ELSE     *** Compile for TopSpeed Pascal ***)
  IMPORT TSBench *;
(*$ENDIF *)

(******************************************************************************)

  VAR
    TestFile : Text;

  PROCEDURE FileStore;
    VAR I : BmInt;
  BEGIN

    Assign(TestFile,'TEST.DAT');
    Rewrite(TestFile);

    FOR I := 1 TO 1000 DO
    BEGIN
      Write(TestFile,'1');
      Write(TestFile,'2');
      Write(TestFile,'3');
      Write(TestFile,'4');
      Write(TestFile,'5');
      Write(TestFile,'6');
      Write(TestFile,'7');
      Write(TestFile,'8');
      Write(TestFile,'9');
      Write(TestFile,'0');
      Write(TestFile,'q');
      Write(TestFile,'w');
      Write(TestFile,'e');
      Write(TestFile,'r');
      Write(TestFile,'t');
      Write(TestFile,'y');
      Write(TestFile,'u');
      Write(TestFile,'i');
      Write(TestFile,'o');
      Write(TestFile,'p')
    END;

    Close(TestFile);
    Erase(TestFile);
  END;

BEGIN
  WriteLn('Store Benchmark');

(******************************************************************************)
(*  Compute the looping overhead.  The Dummy procedure must have some side-   *)
(*  effect so that it is not optimised out of existence.                      *)
(******************************************************************************)

  StartTimer;                                   (* Start the clock.           *)

  REPEAT
    Dummy;
  UNTIL NullTimesUp;

(******************************************************************************)
(*  Now run the benchmark.  Note that the Dummy procedure is also called so   *)
(*  that we can eliminate its overhead from the looping overhead.             *)
(******************************************************************************)

  StartTimer;                                   (* Start the clock.           *)

  REPEAT
    FileStore;
    Dummy
  UNTIL BenchTimesUp;

(******************************************************************************)

  ReportTimes;

END.
