(******************************************************************************)
(*                                 TSCRN.PAS                                  *)
(*                           Screen Write Benchmark.                          *)
(******************************************************************************)

PROGRAM Tscrn(Output);

(******************************************************************************)
(*                                TIMING                                      *)
(******************************************************************************)

(*$IFNDEF TopSpeed *)
 (*%F TRUE   *** Compile for Turbo Pascal ***)
  USES TPBench;
 (*%E*)
(*$ELSE     *** Compile for TopSpeed Pascal ***)
  IMPORT TSBench *;
(*$ENDIF *)

(******************************************************************************)

  PROCEDURE TextScrn;
    VAR I : BmInt;
  BEGIN

    FOR I := 1 TO 1000 DO
      WriteLn('(', I:5, ') 1234567890qwertyuiop');

  END;

BEGIN
  WriteLn('TextScrn Benchmark');

(******************************************************************************)
(*  Compute the looping overhead.  The Dummy procedure must have some side-   *)
(*  effect so that it is not optimised out of existence.                      *)
(******************************************************************************)

  StartTimer;                                   (* Start the clock.           *)

  REPEAT
    Dummy;
  UNTIL NullTimesUp;

(******************************************************************************)
(*  Now run the benchmark.  Note that the Dummy procedure is also called so   *)
(*  that we can eliminate its overhead from the looping overhead.             *)
(******************************************************************************)

  StartTimer;                                   (* Start the clock.           *)

  REPEAT
    TextScrn;
    Dummy
  UNTIL BenchTimesUp;

(******************************************************************************)

  ReportTimes;

END.
